#include <stdio.h>
#include <string.h>

#include "ButtonsPOD.h"

ButtonsPOD::ButtonsPOD() : POD()
{
#if (DEBUG_OBJECTS)
   printf("In ButtonsPOD ()\n");
#endif
   PODType = POD_TYPE_BUTTONS;
   NumberOfButtons = QueryNumberOfButtons();
}

ButtonsPOD::ButtonsPOD(int DeviceNum,int PortNum) : POD(DeviceNum, PortNum)
{
#if (DEBUG_OBJECTS)
   printf("In ButtonsPOD (%d, %d)\n", DeviceNum, PortNum);
#endif
   if (PODType != POD_TYPE_BUTTONS) printf("I'm not that type of POD\n");
   else
   {
      NumberOfButtons = QueryNumberOfButtons();
   }
}

ButtonsPOD::ButtonsPOD(int DeviceNum) : POD(DeviceNum)
{
#if (DEBUG_OBJECTS)
   printf("In ButtonsPOD (%d)\n", DeviceNum);
#endif
   if (PODType != POD_TYPE_BUTTONS) printf("I'm not that type of POD\n");
   else
   {
      NumberOfButtons = QueryNumberOfButtons();
   }
}

int ButtonsPOD::Test()
{
   int Counter;

   printf("Testing a Buttons POD\n");
   for (Counter = 0 ; Counter < NumberOfButtons ; Counter ++)
   {
      printf("Button %d: %d\n", Counter, GetStatus(Counter));
   }
   return(0);
}

int ButtonsPOD::GetStatus(int ButtonNumber)
{
   int Result;
   unsigned char Data[10];
   int Response;
   int ButtonStatus;

   SendCommand(POD_COMMAND_BUTTONS_GET_STATUS);
   Result = ReceiveBytes(0x02, Data);
   Response = Data[0];

//   printf("Buttons: 0x%02X\n", Data[1]);
   ButtonStatus = (Data[1] & (0x01 << ButtonNumber)) && 0x0F;
//   if (Data[1] & (0x01 << ButtonNumber)) ButtonStatus = 1;
//   else ButtonStatus = 0;
   if (Response == POD_RESPONSE_ACK) return(ButtonStatus);
   return(POD_ERROR_BADRESPONSE);
}

int ButtonsPOD::QueryNumberOfButtons()
{
   int Result;
   unsigned char Data[10];
   int Response;

   SendCommand(POD_COMMAND_BUTTONS_GET_NUMBER);
   Result = ReceiveBytes(0x02, Data);
   Response = Data[0];

   if (Response == POD_RESPONSE_ACK) return(Data[1]);
   return(POD_ERROR_BADRESPONSE);
}

int ButtonsPOD::GetNumberOfButtons()
{
   return(NumberOfButtons);
}

