#include <stdio.h>
#include <string.h>

#include "CompassPOD.h"

CompassPOD::CompassPOD() : POD()
{
#if (DEBUG_OBJECTS)
   printf("In CompassPOD ()\n");
#endif
   PODType = POD_TYPE_COMPASS;
}

CompassPOD::CompassPOD(int DeviceNum,int PortNum) : POD(DeviceNum, PortNum)
{
#if (DEBUG_OBJECTS)
   printf("In CompassPOD (int, int)\n");
#endif
   if (PODType != POD_TYPE_COMPASS) printf("I'm not that type of POD\n");
}

CompassPOD::CompassPOD(int DeviceNum) : POD(DeviceNum)
{
#if (DEBUG_OBJECTS)
   printf("In CompassPOD (int)\n");
#endif
   if (PODType != POD_TYPE_COMPASS) printf("I'm not that type of POD\n");
}

int CompassPOD::Test()
{
   printf("The compass detects a heading of %.1f\n", GetHeading());
   return(0);
}

float CompassPOD::GetHeading()
{
   int Result;
   unsigned char Data[10];
   int Response;
   float ReturnValue;

   SendCommand(POD_COMMAND_COMPASS_GET_HEADING);
   Result = ReceiveBytes(0x03, Data);
   Response = Data[0];
   ReturnValue = (float)((Data[1] << 8) | Data[2]) / 10.0;
   if (Response == POD_RESPONSE_ACK) return(ReturnValue);
   return(POD_ERROR_BADRESPONSE);
}

float CompassPOD::GetHeading(char *HeadingString)
{
   float Degrees;
   int Hash;
   char *Directions[] = {
      "N", "NNE", "NE", "ENE",
      "E", "ESE", "SE", "SSE",
      "S", "SSW", "SW", "WSW",
      "W", "WNW", "NW", "NNW"};

   Degrees = GetHeading();
   if (Degrees < 0) return(Degrees); /* an error occurred in GetHeading() */
   Hash = (int)(((Degrees / 22.5) + .5));
   Hash %= 16;
   strncpy(HeadingString, Directions[Hash], 4);
   return(Degrees);
}
