#include <stdio.h>

#include "PowerSensorPOD.h"

PowerSensorPOD::PowerSensorPOD() : POD()
{
#if (DEBUG_OBJECTS)
   printf("In PowerSensorPOD ()\n");
#endif
   PODType = POD_TYPE_POWERSENSOR;
}

PowerSensorPOD::PowerSensorPOD(int DeviceNum,int PortNum) : POD(DeviceNum, PortNum)
{
#if (DEBUG_OBJECTS)
   printf("In PowerSensorPOD (int, int)\n");
#endif
   if (PODType != POD_TYPE_POWERSENSOR) printf("I'm not that type of POD\n");
}

PowerSensorPOD::PowerSensorPOD(int DeviceNum) : POD(DeviceNum)
{
#if (DEBUG_OBJECTS)
   printf("In PowerSensorPOD (int)\n");
#endif
   if (PODType != POD_TYPE_POWERSENSOR) printf("I'm not that type of POD\n");
}

int PowerSensorPOD::Test()
{
   printf("The power is %d\n", GetPowerStatus());
   return(0);
}

int PowerSensorPOD::GetPowerStatus()
{
   int Result;
   unsigned char Data[10];
   int Response;

   SendCommand(POD_COMMAND_POWERSENSOR_GET_STATUS);
   Result = ReceiveBytes(0x02, Data);
   Response = Data[0];
   if (Response == POD_RESPONSE_ACK) return(Data[1]);
   return(POD_ERROR_BADRESPONSE);
}


