#include <stdio.h>

#include "SonarPOD.h"

SonarPOD::SonarPOD() : POD()
{
#if (DEBUG_OBJECTS)
   printf("In SonarPOD ()\n");
#endif
   PODType = POD_TYPE_DISTANCE;
}

SonarPOD::SonarPOD(int DeviceNum,int PortNum) : POD(DeviceNum, PortNum)
{
#if (DEBUG_OBJECTS)
   printf("In SonarPOD (%d, %d)\n", DeviceNum, PortNum);
#endif
   if (PODType != POD_TYPE_DISTANCE) printf("I'm not that type of POD\n");
}

SonarPOD::SonarPOD(int DeviceNum) : POD(DeviceNum)
{
#if (DEBUG_OBJECTS)
   printf("In SonarPOD (%d)\n", DeviceNum);
#endif
   if (PODType != POD_TYPE_DISTANCE) printf("I'm not that type of POD\n");
}

int SonarPOD::Test()
{
   printf("The distance is %d inches", GetDistanceInches());
   printf("or %d centimeters\n", GetDistance_cm());
   return(0);
}

int SonarPOD::GetDistanceInches()
{
   return(GetDistance_in());
}

int SonarPOD::GetDistance_in()
{
   int Result;
   unsigned char Data[10];
   int Response;

   SendCommand(POD_COMMAND_DISTANCE_GET_INCHES);
   Result = ReceiveBytes(0x03, Data);
   Response = Data[0];
   if (Response == POD_RESPONSE_ACK) return((Data[1] << 8) | Data[2]);
   return(POD_ERROR_BADRESPONSE);
}

int SonarPOD::GetDistance_cm()
{
   int Result;
   unsigned char Data[10];
   int Response;

   SendCommand(POD_COMMAND_DISTANCE_GET_CM);
   Result = ReceiveBytes(0x03, Data);
   Response = Data[0];
   if (Response == POD_RESPONSE_ACK) return((Data[1] << 8) | Data[2]);
   return(POD_ERROR_BADRESPONSE);
}

