#include <stdio.h>

#include "gPODEnv.h"

gPODEnv::gPODEnv(int _Options) : PODEnv(_Options)
{
}

int gPODEnv::DisplayStatus(int Status, int CurrentPODNumber)
{
   double ProgressValue;

   if (Options & POD_ENV_OPTION_GUI_STATUS)
   {
      if (CurrentPODNumber == 0) ProgressValue = 0.0;
      else if (CurrentPODNumber >= MAXPODS) ProgressValue = 1.0;
      else ProgressValue = (CurrentPODNumber + 1.0) / (MAXPODS + 1.0);

      DisplayProgressBar(Status, ProgressValue);
   }
   if (Options & POD_ENV_OPTION_TEXT_STATUS)
   {
      PODEnv::DisplayStatus(Status, CurrentPODNumber);
//      return(PODEnv::DisplayStatus(Status, CurrentPODNumber));
   }
   return(0);
}

void gPODEnv::DestroyProgressBar( GtkWidget *Widget, ProgressBarData *Pdata)
{
   Pdata->Window = NULL;
   g_free (Pdata);
   gtk_main_quit();
}

int gPODEnv::DisplayProgressBar(int Status, gdouble ProgressValue)
{
   static ProgressBarData *ProgressBar;
   static int Initialized = 0;

   if (!Initialized)
   {
      GdkColor Color;

      ProgressBar = (ProgressBarData *) g_malloc (sizeof (ProgressBarData));
      ProgressBar->Window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_window_set_default_size(GTK_WINDOW(ProgressBar->Window), 150, 40);
      gtk_window_set_resizable (GTK_WINDOW (ProgressBar->Window), TRUE);
      gtk_signal_connect (GTK_OBJECT(ProgressBar->Window), "destroy", GTK_SIGNAL_FUNC((&DestroyProgressBar)), (gpointer)ProgressBar);
      gtk_window_set_title (GTK_WINDOW (ProgressBar->Window), "Detecting PODs");
      gtk_container_set_border_width (GTK_CONTAINER (ProgressBar->Window), 0);
      ProgressBar->Pbar = gtk_progress_bar_new ();
      gtk_container_add (GTK_CONTAINER (ProgressBar->Window), ProgressBar->Pbar);
      gtk_widget_show (ProgressBar->Pbar);
      Color.red = 0;
      Color.green = 0;
      Color.blue = 65535;
      gtk_widget_modify_fg (ProgressBar->Pbar, GTK_STATE_NORMAL, &Color);

      Color.red = 0;
      Color.green = 0;
      Color.blue = 0;
      gtk_widget_modify_bg (ProgressBar->Pbar, GTK_STATE_NORMAL, &Color);
      Initialized ++;
   }

   if (Status == 1) /* Display/Update */
   {
      char TempText[100];

      gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (ProgressBar->Pbar), ProgressValue);
      sprintf(TempText, "%3.1f %%", ProgressValue * 100.0);
      gtk_progress_bar_set_text (GTK_PROGRESS_BAR (ProgressBar->Pbar), MakeUTF8(TempText));
      gtk_widget_show (ProgressBar->Window); /* Display the Window */
   }
   else
   {
      gtk_widget_hide(ProgressBar->Window);
   }
   while (g_main_iteration (FALSE)); /* Display the progress bar */
   return(0);
}

char *gPODEnv::MakeUTF8(const char *latin1)
{
   static char *ReturnValue;
   const char *p;
   GString *utf8;

   utf8 = g_string_new (NULL);
   for (p = latin1; *p != '\0'; p++) g_string_append_unichar (utf8, (gunichar) *p);
   ReturnValue = g_string_free (utf8, FALSE);
   return(ReturnValue);
}

